extends base.pug
//- load leaflet_tags
- load static

block add_head
  meta(charset='utf-8')
  meta(content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" name="viewport")

  //link(rel='stylesheet' href='https://cdn.jsdelivr.net/gh/openlayers/openlayers.github.io@master/en/v6.14.1/css/ol.css' type='text/css')
  //script(src='https://cdn.jsdelivr.net/gh/openlayers/openlayers.github.io@master/en/v6.14.1/build/ol.js')
  title OpenLayers Ruta Local
  meta(charset='UTF-8')
  // Openlayers
  link(rel='stylesheet' href='https://cdn.jsdelivr.net/npm/ol@v7.1.0/ol.css')
  script(type='text/javascript' src='https://cdn.jsdelivr.net/npm/ol@v7.1.0/dist/ol.js')
  script(src='https://cdn.polyfill.io/v2/polyfill.min.js?features=requestAnimationFrame,Element.prototype.classList,URL,Object.assign')
  // ol-ext
  link(rel='stylesheet' href='https://cdn.rawgit.com/Viglino/ol-ext/master/dist/ol-ext.min.css')
  script(type='text/javascript' src='https://cdn.rawgit.com/Viglino/ol-ext/master/dist/ol-ext.min.js')z
  style.
    .ol-zoombt {
    display: none !important;
    }
    .locate {
      top: 6em;
      left: .5em;
    }
    .resultsbarhight {
        height: 70vh;
    }

block title
  | Ruta Local

block content
  .grid.grid-cols-12.bg-green-100(x-data="CargarFunciones();" x-init="connect();" @keydown.escape='showModal = false')
    .col-span-12.text-center
      div.content-center.pt-1.pb-1
        select#zona_select(name='zona_select' @change="CenterMap(event);")
          {% for z in zonas %}
          option(value='{{ z.id }}'){{ z.nombre }}
            //mapzoom="{{z.zoom}}" mapcenter="[{{z.centro.0}},{{z.centro.1}}]") 
          {% endfor %}
    .col-span-12.z-10(style="height: 70vh;" class="md:col-span-10")
        #map.map(style="border: none; position: relative; top: 0; left: 0; right: 0; bottom: 0; height: 100%; width: 100%;")
          #popup.ol-popup
            a#popup-closer.ol-popup-closer(href='#')
            #popup-content
    template(x-if="listresults")
      .col-span-12.col-start-2.col-end-12.content-center.overflow-x-scroll.items-center(class="md:col-span-2 md:h-[70vh] md:overflow-y-scroll ")
        div(class="grid grid-flow-col gap-4 items-center md:grid-flow-row md:grid-cols-1 ")
              template(x-for="resultado in listresults")
                div.items-center(class="flex justify-center")
                  template(x-if="selectfeaturedict[resultado.feature.values_.tipo_oferta].select")
                   button.my-1.m-1.py-1(class="w-32 bg-cover bg-orange-500 hover:bg-orange-700 text-white py-2 px-2 rounded" @click="resultdict=resultado.feature.values_;buttonclickactionmap(resultado.feature);")
                        .grid.grid-cols-1.object-contain  
                            div.cols-grid-1(class="font-bold")
                              img.mx-1(x-bind:src="selectfeaturedict[resultado.feature.values_.tipo_oferta].img" style="float:left;vertical-align:middle;margin:3px 2px 2px 2px" width="20" height="20")
                              i
                                span(x-text="resultado.distance")
                                |&nbsp;km
                            div.cols-span-1
                                  span(x-text="resultado.feature.values_.nombre")
                                  |
    template(x-if="listresults == false")
      .col-span-12(class="text-center align-middle justify-center md:col-span-2 md:overflow-auto")	
        i
          | click en el mapa para seleccionar puntos o buscar por cercanía.
  
    .col-span-12.col-start-2.col-end-12.content-center.overflow-x-scroll.p-2
      div.items-center.flex-row(class="grid grid-rows-1 grid-flow-col gap-2")
        template(x-for="[id, dict] in Object.entries(selectfeaturedict)")
          div.col-span-1
            //span(x-text="dict.nombre")
            .grid.grid-cols-2
              .object-center	
                img(:src="dict.img" width="25" height="25")
              input(type="checkbox" name="dict.id" :value="dict.select" :checked="dict.select" x-model="selectfeaturedict[id].select" @change="vectorLayer.getSource().changed();")

            //template(x-for="[id, dict] in Object.entries(selectfeaturedict)")
            //  div 
            //    span(x-text="dict.select")  
    .col-span-9.content-center
          #distancebar.fixed.inset-0.z-30.flex.items-center.justify-center.overflow-auto.bg-black.bg-opacity-50(x-show='showModal')
            .max-w-3xl.px-6.py-4.mx-auto.text-left.bg-white.rounded.shadow-lg(@click.away='showModal = false' x-transition:enter='motion-safe:ease-out duration-300' x-transition:enter-start='opacity-0 scale-90' x-transition:enter-end='opacity-100 scale-100')
              .flex.items-center.justify-between
                h5.mr-3.text-black.max-w-none 
                  |
                button.z-50.cursor-pointer(type='button' @click='showModal = false')
                  svg(xmlns='http://www.w3.org/2000/svg' width='24' height='24' viewbox='0 0 24 24' fill='none' stroke='currentColor')
                    path(stroke-linecap='round' stroke-linejoin='round' stroke-width='2' d='M6 18L18 6M6 6l12 12')
              // content
              div
                template(x-if="resultdict")
                    div
                      .grid.grid-cols-2
                        div(class="w-1/4")
                          img(src="{% static 'icons/whtsp.svg' %}" style="display: block;margin-left: auto;margin-right: auto;" height=20 width=20)
                        div(class="w-3/4")
                          h1.text-center.font-medium.leading-tight.text-2xl.mt-0.text-green.p-2
                             span(x-text="resultdict.nombre")
                           //|{{result.nombre}}
                      .grid.grid-cols-3
                        .col-span-1.py-2 
                            a.text-center.underline(x-bind:href= "'https://api.whatsapp.com/send?phone=' + resultdict.phone + '&text=Hola! encontré su contacto en RutaLocal.cl'", target="_blank")
                              img(src="{% static 'icons/whtsp.svg' %}" style="display: block;margin-left: auto;margin-right: auto;" height=20 width=20)
                              //div(class="px-2") 
                              //  |contactar
                        .col-span-1.py-2 
                            a.text-center.underline(x-bind:href="'https://www.google.com/maps/dir//'+ol.proj.toLonLat(resultdict.geometry.flatCoordinates)[1].toString()+','+ol.proj.toLonLat(resultdict.geometry.flatCoordinates)[0].toString()+'/@'+ol.proj.toLonLat(resultdict.geometry.flatCoordinates)[1].toString()+','+ol.proj.toLonLat(resultdict.geometry.flatCoordinates)[0].toString()+',13z'", target="_blank")
                              img(src="{% static 'icons/gmap.png' %}" style="display: block;margin-left: auto;margin-right: auto;" height=20 width=20)
                        .col-span-1.py-2 
                            a.text-center.underline(x-bind:href="'https://www.instagram.com/'+resultdict.insta", target="_blank")
                              img(src="{% static 'icons/inta.jpeg' %}" style="display: block;margin-left: auto;margin-right: auto;" height=20 width=20)

                              //div(class="px-2") 
                              //  |cómo llegar
                      div
                          .text-center
                              span(x-text="resultdict.descripcion")
                              //{{result.descripcion}}
                          //-if result.ruta
                  
      
  style.
    .ol-zoombt {
    display: none;
    }
  script(type='text/javascript').
    function CargarFunciones(){
      return{
      showModal:false,
      listresults: false,
      panel: null,
      resultdict: false,
      selectfeaturedict: {
              {% for indice, dictselect in selectfeatures.items %}
                    {{indice}}: {'img':"{% static dictselect.icon %}", 'select':true, 'nombre':"{{dictselect.nombre}}" } ,
              {% endfor %}
                    },
      map: null,
      popup: null,
      vectorSource:null,
      xyz:null,
      vectorLayer:null,
      vectorLayerMyGeoLoc: null,
      stylesdict : {}, 
      zonas: [
                {% for z in zonas %}
                {
                id: {{z.id}},
                zoom: {{z.zoom}},
                centro: [{{z.centro.0}},{{z.centro.1}}],
                descripcion: '{{z.descripcion}}',
                },
                {% endfor%}
            ],
      CenterMap(zona_id) {
                //console.log("Long: " + long + " Lat: " + lat);
                //var newzona = zonas.filter(m => m.date.toDateString() ===  zona_id);
                var newzona = this.zonas.filter(z => z.id ==  zona_id.target.value)[0];
                this.map.getView().setCenter(ol.proj.transform(newzona.centro, 'EPSG:4326', 'EPSG:3857'));
                this.map.getView().setZoom(newzona.zoom);
             },

      distanceBetweenPoints(latlng1, latlng2){
              var line = new ol.geom.LineString([latlng1, latlng2]);
              //console.log('holi')
              return Math.round(line.getLength()/1000 * 100) / 100 ;
          },
      distancestoallpoints(coordinate){
        var feat = this.vectorSource.getFeatures();
        var base = coordinate;
        //console.log(coordinate);
        this.listresults= [];
        this.vectorSource.forEachFeature( (feature) => {if(true){console.log(feature);this.listresults.push({'distance':this.distanceBetweenPoints(base,feature.values_.geometry.flatCoordinates),'feature':feature});}});
        this.listresults.sort(function(a,b) {return a.distance - b.distance});
        //console.log(this.listresults);
      },
      buttonclickactionmap(feature){
          //console.log(feature);
          if (feature instanceof ol.Feature) {
            this.map.getView().fit(feature.getGeometry(),
                                              {
                                    maxZoom: this.map.getView().getMaxZoom() - (this.map.getView().getMaxZoom() - this.map.getView().getMinZoom())/5,
                                    duration: 1000
                                  }
            );   
            //console.log(feature);
            this.select.getFeatures().clear()// -> removes the selected items
            this.select.getFeatures().push(feature) //-> selects the applied feature
            //this.select.getFeatures().on.events.listeners.click[0].func.call(feature, event);
            //console.log('start--');
            //this.popup.setContentHTML('holaaaaa');
            //for (pop in this.popup){
            //    console.log(pop);
            //}
            //console.log(this.popup);
            this.popup.show(feature);
            //selected = new ol.Control.SelectFeature(feature);
            }
      } ,
      triggerpanel(e){
        console.log(e);
      }
      ,
      connect(){
        //console.log(this.stylesdict);
        //this.stylesdict = {               
                
        this.xyz= new ol.source.XYZ({url: "{{settings.TILE}}"});
        this.vectorSource= new ol.source.Vector({
        url: 
              //'https://rutalocal.nestolab.cl'+
              //'http://localhost:8081'+
              //"{{current_site}}"+
              '/wfs/ot/'+
              '?service=WFS&' +
              'version=2.0.0&request=GetFeature&typename=ofertaturistica&'+
              'outputFormat=application/json'
        ,
        format: new ol.format.GeoJSON(),
        });
        //console.log(this.stylesdict);

        this.vectorLayer= new ol.layer.Vector({
            source: this.vectorSource,
            displayInLayerSwitcher: false,
            style: (feature) => {
                          //console.log(this.stylesdict);
                          //console.log(feature.get("tipo_oferta"));
                    if (this.selectfeaturedict[feature.get("tipo_oferta")].select){
                          s = new ol.style.Style({
                            image: new ol.style.Icon({src: this.selectfeaturedict[feature.get("tipo_oferta")].img, anchor: [0.5, 0.5]})
                            });
                          var actualZoom = this.map.getView().getZoom();
                          var MaxZoom = this.map.getView().getMaxZoom();
                          var MinZoom = this.map.getView().getMinZoom();
                          s.getImage().setScale(Math.max(0.07*10**(-(MaxZoom-actualZoom)/(MaxZoom-MinZoom)),0.01))
                    }else{
                          s = new ol.style.Style({
                                        stroke: new ol.style.Stroke({
                                            color: 'blue',
                                            width: 1
                                            })
                                        });
                    };
                    return s;
                    }
                    
              });

        //this.vectorLayerMyGeoLoc= new ol.layer.Vector({
        //    source: new ol.source.Vector(),
        //    displayInLayerSwitcher: false,
        //    style: new ol.style.Style({
        //                    image: new ol.style.Icon({src: "{% static 'icons/ask.png' %}", anchor: [0.5, 0.5]})
        //                    }),                   
        //      });


        //console.log(this.vectorLayerMyGeoLoc);
        selectedStyle = {
              LineString: new ol.style.Style({
                  stroke: new ol.style.Stroke({
                        color: 'blue',
                        width: 8
                  })
              }),
              Polygon: new ol.style.Style({
                  stroke: new ol.style.Stroke({
                      color: 'blue',
                      width: 4
                    }),
                  fill: new ol.style.Fill({
                      color: 'rgba(0, 0, 255, 0.1)'
                  })
                  }),
              Point: new ol.style.Style({
                  image: new ol.style.RegularShape({
                      fill: new ol.style.Fill({
                          color: 'rgba(255, 255, 255, 0.5)'
                      }),
                      stroke: new ol.style.Stroke({
                          color: 'orange',
                          width: 10
                      }),
                      points: 4,
                      radius: 2,
                      angle: Math.PI / 4
                        })
                })
        };

        var selectedStyleFunction = (feature, resolution) => {

            if (feature instanceof ol.Feature){
            //var featureStyleFunction = feature.getStyleFunction();
            
            var typef = feature.getGeometry().getType();
            //console.log(type);
            return selectedStyle[typef];
            }
        };

        // popup features
        this.select= new ol.interaction.Select({
                  hitTolerance: 6,
                  style: selectedStyleFunction,
                  multi:true,
                  condition: ol.events.condition.singleClick
                });


        // Popup associated with the select
        this.popup= new ol.Overlay.PopupFeature({
        popupClass: 'default anim',
        canFix: false,
        closeBox: true,
        select: this.select,
        showImage: false,
        template: {
        title: 
          (f) => {
            //console.log(this.stylesdict[f.get("tipo_oferta")].getSrc);
            return "<img width='25' height='25' src='"+this.selectfeaturedict[f.get("tipo_oferta")].img+"'></img>+<b>"+f.get('nombre')+"</b><br><button type='button' @click='showModal = true' class='my-1 m-1 py-1 w-auto display:inline-block bg-cover bg-orange-500 hover:bg-orange-700 text-white font-bold py-2 px-2 rounded'>+ Info</button>";
          },
        attributes:{},
        },

        });
        //const container = document.getElementById('popup');
        
        
        //const attributtionscontainer = document.getElementById('attributtionscontainer');
        const container = document.getElementById('popup');
        const content = document.getElementById('popup-content');
        const closer = document.getElementById('popup-closer');

        //const popup =  new ol.Overlay({
        //  element: container,
        //  autoPan: {
        //    animation: {
        //      duration: 250,
        //    },
        //  },
        //});

        this.popup.on('select', (e) => {
          this.resultdict=e.feature.values_;
          //console.log('waat');
          });// this.loadSelectedResult(e));

        // popup and distance functionality



        /**
         * Create an overlay to anchor the popup to the map.
         */
        const overlay =  new ol.Overlay({
          element: container,
          autoPan: {
            animation: {
              duration: 100,
            },
          },
        });

        /**
         * Add a click handler to hide the popup.
         * @return {boolean} Don't follow the href.
         */
        closer.onclick = function () {
          overlay.setPosition(undefined);
          closer.blur();
          return false;
        };

        var layerswitcher = new ol.control.LayerSwitcher({
          collapsed: true,
          mouseover: true,
          reordering: false,
          extent:false,
          show_progress:true,
        });

        //layerswitcher.on('toggle', (e) => {
        //  console.log('Collapse layerswitcher', e.collapsed);
        //});

        var scale = new ol.control.ScaleLine({
          minWidth: 64,
          maxWidth: 2000,
          bar: false,
          steps:4,
          text:false,
          dpi: undefined,
        });
        
        var zoomslider = new ol.control.ZoomSlider({
          duration: 500,
          className : 'ol-zoomslider',

        });
        var fullscreen = new ol.control.FullScreen({
          //duration: 200,
          //className : 'ol-zoomslider',

        });

        var mouseposition = new ol.control.MousePosition({
          //duration: 200,
          //className : 'ol-zoomslider',

        });
        var ovmap = new ol.control.OverviewMap({
          //duration: 200,
          //className : 'ol-zoomslider',

        });
        var rotate = new ol.control.Rotate({
        //  duration: 200,
        //  className : 'ol-zoomslider',

        });
        var zoom = new ol.control.Zoom({
          //zoom: 200,
          //className : 'ol-zoomslider',

        });
        var zoomextent = new ol.control.ZoomToExtent({
          //duration: 200,
          //className : 'ol-zoomslider',

        });
        var attribution = new ol.control.Attribution({
          //target: attributtionscontainer,
          collapsed:false,
          //collapsible:false,
          //duration: 200,
          //className : 'ol-zoomslider',

        });

        var geob = new ol.control.GeolocationButton({
          title:'Mi posición',
          delay:180*360,

          //target: attributtionscontainer,
          //collapsed:false,
          //collapsible:false,
          //duration: 200,
          //className : 'ol-zoomslider',

        });
        
        //console.log(geob);
        
        //const locate = document.createElement('div');
        //locate.className = 'ol-control ol-unselectable locate';
        //locate.innerHTML = '<button title="Mi Locación">◎</button>';
        //locate.addEventListener('click', function () {
        //  if (!this.vectorLayerMyGeoLoc.isEmpty()) {
        //    this.map.getView().fit(this.vectorLayerMyGeoLoc.getExtent(), {
        //      maxZoom: 18,
        //      duration: 500,
        //    })
        //  }
        //});


        
        var layersen = new ol.layer.Tile({
                            title: "Actual: Sentinel-2",
                            baseLayer: true,
                            source: this.xyz,
                            });
        var layerg = new ol.layer.Tile({
                            title: "+Resolución Google",
                            baseLayer: false,
                            visible: true,
                            opacity: 0.45,
                            source: new ol.source.XYZ({url: "http://mt0.google.com/vt/lyrs=s&hl=en&x={x}&y={y}&z={z}&s=Ga"})
                            });

        //var layergc = new ol.layer.Tile({
        //                    title: "Caminos Google",
        //                    baseLayer: false,
        //                    visible: true,
        //                    opacity: 0.5,
        //                    source: new ol.source.XYZ({url: "https://mt1.google.com/vt/lyrs=h&x={x}&y={y}&z={z}"})
        //                    }); 
        //var layergc2 = new ol.layer.Tile({
        //                    title: "Terreno OpenTopo",
        //                    baseLayer: false,
        //                    visible: false,
        //                    opacity:1,
        //                    contrast: 0.1,
        //                    source: new ol.source.XYZ({url: "https://tile.opentopomap.org/{z}/{x}/{y}.png"})
        //                    });
        var layergc3 = new ol.layer.Tile({
                            title: "Caminos Google",
                            baseLayer: false,
                            visible: true,
                            opacity: 1,
                            source: new ol.source.XYZ({url: "https://mts0.google.com/vt/lyrs=h@159000000,traffic|seconds_into_week:-1&hl=en&src=app&x={x}&y={y}&z={z}&s=Gal&apistyle=s.t%3A2|s.e%3Al|p.v%3Aoff"})
                            });

        
        //this.panel = new ol.Control.Panel();//{defaultControl: btnHiLite});

        
        
        
        this.map = new ol.Map({
                        target: 'map',
                        //interactions: ol.interaction.defaults({ altShiftDragRotate:false, pinchRotate:false }),
                        controls: [layerswitcher,scale,zoom,fullscreen, geob],//,this.panel],
                        layers: [layersen,layerg,layergc3,this.vectorLayer],
                        overlays: [overlay,this.popup],
                        view: new ol.View({
                          center: ol.proj.fromLonLat({{settings.CENTER}}),
                          zoom: {{settings.ZOOM}},
                          minZoom: 7,
                          maxZoom: 16,
                          })
                        });
        //this.map.addOverlay(this.popup);
        //this.map.addControl(
        //  new ol.control.Control({
        //    element: locate,
        //  })
        //);    
        
        //this.map.addControl (new ol.control.LayerSwitcherImage());

        this.map.addInteraction(this.select);
           // Reset layer data when too much features in memory
        this.map.on('moveend', (e) => {if (this.vectorSource.getFeatures().length > 30000) {this.vectorSource.refresh();}});
        
        /**
         * Add a click handler to the map to render the popup.
         */
        geob.on('change:active', (e) =>{
              //console.log('holi');
              console.log(e.target);
              //console.log(e.target.interaction_.geolocation);
              //console.log(e.target.interaction_.geolocation.A.position);
              //console.log(geob.interaction_.geolocation.A.position);
              //console.log(e);
              //if (e.active && e.target.interaction_.geolocation.A.position){
                //overlay.setPosition(e.coordinate);
                //here.show(e.coordinate, "You are<br/>here!");
              const coordinate = e.coordinate;
              console.log(coordinate);
              if (coordinate !== undefined){
                content.innerHTML = "<img height=25 width=25 src={% static 'icons/ask.png' %}>";
                this.distancestoallpoints(coordinate);
                overlay.setPosition(coordinate);
              };
              //const hdms = ol.coordinate.toStringHDMS(ol.proj.toLonLat(coordinate));
              //content.innerHTML = '<p>Buscando cercanía:</p><code>' + hdms + '</code>';

              //};
              
        });

        this.map.on('singleclick', (evt) => {
          const coordinate = evt.coordinate;
          //const hdms = ol.coordinate.toStringHDMS(ol.proj.toLonLat(coordinate));
          //console.log(coordinate)
          //content.innerHTML = '<p>Buscando cercanía:</p><code>' + hdms + '</code>';
          var db = document.getElementById('distancebar');
          db.scrollTop = 0;
          content.innerHTML = "<img height=25 width=25 src={% static 'icons/ask.png' %}>";
          overlay.setPosition(coordinate);
          this.distancestoallpoints(coordinate);

          //this.distancestoallpoints(coordinate);

        });
        
        //var geolocation = new ol.Geolocation({
        //  // take the projection to use from the map's view
        //  projection: this.map.getView().getProjection()
        //});
        //// listen to changes in position
        //console.log(geolocation);
        //geolocation.on('change', (evt) => {
        //  window.console.log(geolocation.getPosition());
        //  content.innerHTML = "<img height=25 width=25 src={% static 'icons/ask.png' %}>";
        //  overlay.setPosition(geolocation.getPosition());
        //  this.distancestoallpoints(geolocation.getPosition());
        //});
      
      },
      }
    };